/******************************************************************************
 * Includes
 *****************************************************************************/

#include <config.h>
#include <framework.h>
#include <consol.h>
#include <printf_P.h>
#include "general.h"
#include <lpc2xxx.h>

char in[20];

tU32 addr, data;

int isHex(char c)
{
	if((c>='0') && (c<='9')) return 1;
	if((c>='a') && (c<='f')) return 1;

	return 0;
}

unsigned hex(char c)
{
	if((c>='0') && (c<='9')) return (unsigned) c-'0';
	if((c>='a') && (c<='f')) return (unsigned) c-'a'+10;

	return 0;
}

char scan(tU32 *addr, tU32 *data)
{
	char retVal = ' ';
	char *ptr;

	*addr = 0;
	*data = 0;
	consolSendCh('#');
	consolGetString(in);
	if(((in[0] == 'w') && (in[1] == ' ')) ||
	   ((in[0] == 'r') && (in[1] == ' ')))
	{
		do {
			ptr = &in[2];
			while(isHex(*ptr))
			{
				*addr <<= 4;
				*addr += hex(*ptr);
				ptr++;
			}
			if (in[0] == 'r')
			{
				retVal = 'r';
				break;
			}
			else if(*ptr != ' ')
				break;
			ptr++;
			while(isHex(*ptr))
			{
				*data <<= 4;
				*data += hex(*ptr);
				ptr++;
			}


			retVal = in[0];
		} while(0);
	}

	if(retVal == ' ')
	{
		consolSendString("Error in command\n\r");
	}
	return retVal;
}

main()
{
	tU32 addr, data;
	tU32 *ad;
	char ch;
	int i;

	eaInit();

	while(1)
	{
		ch = scan(&addr, &data);
		ad = addr;
		switch(ch) {
			case 'w': *ad = data;
			case 'r': data = *ad;
			          printf("%x=%x\n", addr, data);
			          break;
			default: printf("Error\n");
		}
		printf("%c addr=%x, data=%x", ch, addr, data);
	}
}
